---
name: Bug report
about: If something doesn't work correctly in RPCS3
title: ''
labels: ''
assignees: ''

---

## Please do not ask for help or report compatibility regressions here, use [RPCS3 Discord server](https://discord.me/RPCS3) or [forums](https://forums.rpcs3.net/) instead.

## Quick summary
Please briefly describe what is not working correctly.

## Details

Please describe the problem as accurately as possible.

#### 1. Please attach RPCS3's log.
* Run the game until you find the issue.
* Completely close RPCS3, or move to the next step in case it has crashed.
* Locate RPCS3's log file:
	+ ```RPCS3.log``` (It can show up as just RPCS3 and have a notepad icon)
	or
	+ ```RPCS3.log.gz``` (It can show up as RPCS3.log and have a zip or rar icon)
![image](https://user-images.githubusercontent.com/44116740/84433247-aa15fa80-ac36-11ea-913e-6fe25a1d040e.png)
	On Linux it will be in ```~/.cache/rpcs3/```.
	On Windows it will be near the executable.
* Attach the log:
	+ Drag and drop your log file into the issue.
	+ Or upload it to the cloud, such as Dropbox, Mega etc. 

#### 2. If you describe graphical issue, please provide an RSX capture and a RenderDoc capture that demonstrate it.
* To create an RSX capture, use _Create_ _RSX_ _Capture_ under _Utilities_.
Captures will be stored in RPCS3 folder → captures.
	+ Compress your capture with 7z, Rar etc. 
	And	drag and drop it into the issue.
	+ Or upload it to the cloud, such as Dropbox, Mega etc.
* To create a RenderDoc capture, please refer to [RenderDoc's documentation](https://renderdoc.org/docs/how/how_capture_frame.html).

#### 3. Please attach screenshots of your problem.
* Enable performance overlay with at least medium level of detail.
You can find it in _Emulator_ tab in _Settings_.

#### 4. Please provide comparison with real PS3.

#### 5. Please provide your system configuration:
* OS
* CPU
* GPU
* Driver version
* etc.

#### Please include.
* Anything else you deem to be important
